// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             v4.23.4
// source: err_impl.proto

package learn_go_grpc

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	ErrorImpl_GetName_FullMethodName = "/err.ErrorImpl/GetName"
)

// ErrorImplClient is the client API for ErrorImpl service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ErrorImplClient interface {
	GetName(ctx context.Context, in *Request, opts ...grpc.CallOption) (*Response, error)
}

type errorImplClient struct {
	cc grpc.ClientConnInterface
}

func NewErrorImplClient(cc grpc.ClientConnInterface) ErrorImplClient {
	return &errorImplClient{cc}
}

func (c *errorImplClient) GetName(ctx context.Context, in *Request, opts ...grpc.CallOption) (*Response, error) {
	out := new(Response)
	err := c.cc.Invoke(ctx, ErrorImpl_GetName_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ErrorImplServer is the server API for ErrorImpl service.
// All implementations must embed UnimplementedErrorImplServer
// for forward compatibility
type ErrorImplServer interface {
	GetName(context.Context, *Request) (*Response, error)
	mustEmbedUnimplementedErrorImplServer()
}

// UnimplementedErrorImplServer must be embedded to have forward compatible implementations.
type UnimplementedErrorImplServer struct {
}

func (UnimplementedErrorImplServer) GetName(context.Context, *Request) (*Response, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetName not implemented")
}
func (UnimplementedErrorImplServer) mustEmbedUnimplementedErrorImplServer() {}

// UnsafeErrorImplServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ErrorImplServer will
// result in compilation errors.
type UnsafeErrorImplServer interface {
	mustEmbedUnimplementedErrorImplServer()
}

func RegisterErrorImplServer(s grpc.ServiceRegistrar, srv ErrorImplServer) {
	s.RegisterService(&ErrorImpl_ServiceDesc, srv)
}

func _ErrorImpl_GetName_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Request)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ErrorImplServer).GetName(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ErrorImpl_GetName_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ErrorImplServer).GetName(ctx, req.(*Request))
	}
	return interceptor(ctx, in, info, handler)
}

// ErrorImpl_ServiceDesc is the grpc.ServiceDesc for ErrorImpl service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ErrorImpl_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "err.ErrorImpl",
	HandlerType: (*ErrorImplServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetName",
			Handler:    _ErrorImpl_GetName_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "err_impl.proto",
}
